package org.rzo.yacron4j;

import io.nettyx.util.internal.logging.InternalLogger;
import io.nettyx.util.internal.logging.SimpleLoggerFactory;

import java.util.TimeZone;

public class TaskOptions implements Cloneable
{
	public static int EXCEPTION_CANCEL = 1;
	public static int EXCEPTION_RETRY = 2;
	public static int EXCEPTION_IGNORE = 0;

	public static int DST_CONFLICT_BACKWARD = -1;
	public static int DST_CONFLICT_IMMEDIATE = 0;
	public static int DST_CONFLICT_FORWARD = 1;

	private boolean _allowOverlap = false;
	private boolean _ignoreOnOverlap = true;
	private int _maxConcurrent = 1;
	private boolean _dstConflictIgnore = false;
	private int _dstConflictResolution = DST_CONFLICT_IMMEDIATE;
	private TimeZone _timeZone = TimeZone.getDefault();
	private int _exceptionResolution = EXCEPTION_IGNORE;
	private InternalLogger _logger = SimpleLoggerFactory.getInstance("yacron4j-scheduler");
	private boolean _debug = false;
	private boolean _persist = false;

	public boolean isAllowOverlap()
	{
		return _allowOverlap;
	}

	public void setAllowOverlap(boolean allowOverlap)
	{
		_allowOverlap = allowOverlap;
	}

	public boolean isIgnoreOnOverlap()
	{
		return _ignoreOnOverlap;
	}

	public void setIgnoreOnOverlap(boolean ignoreOnOverlap)
	{
		_ignoreOnOverlap = ignoreOnOverlap;
	}

	public int getMaxConcurrent()
	{
		return _maxConcurrent;
	}

	public void setMaxConcurrent(int maxConcurrent)
	{
		_maxConcurrent = maxConcurrent;
	}

	public boolean isDstConflictIgnore()
	{
		return _dstConflictIgnore;
	}

	public void setDstConflictIgnore(boolean dstConflictIgnore)
	{
		_dstConflictIgnore = dstConflictIgnore;
	}

	public TimeZone getTimeZone()
	{
		return _timeZone;
	}

	public void setTimeZone(TimeZone timeZone)
	{
		_timeZone = timeZone;
	}

	@Override
	protected Object clone()
	{
		try
		{
			return super.clone();
		}
		catch (CloneNotSupportedException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public int getDstConflictResolution()
	{
		return _dstConflictResolution;
	}

	public void setDstConflictResolution(int dstConflictResolution)
	{
		_dstConflictResolution = dstConflictResolution;
	}

	public InternalLogger getLogger()
	{
		return _logger;
	}

	public void setLogger(InternalLogger logger)
	{
		_logger = logger;
	}

	public int getExceptionResolution()
	{
		return _exceptionResolution;
	}

	public void setExceptionResolution(int exceptionResolution)
	{
		_exceptionResolution = exceptionResolution;
	}

	public boolean isDebug()
	{
		return _debug;
	}

	public void setDebug(boolean debug)
	{
		_debug = debug;
	}

	public boolean isPersist()
	{
		return _persist;
	}

	public void setPersist(boolean persist)
	{
		_persist = persist;
	}
}
