package org.rzo.yacron4j.example;

import java.text.ParseException;
import java.util.Date;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

import org.rzo.yacron4j.Scheduler;
import org.rzo.yacron4j.TaskOptions;

public class Shutdown
{

	/**
	 * @param args
	 * @throws ParseException
	 */
	public static void main(String[] args) throws Exception
	{
		Scheduler scheduler = new Scheduler();
		String cronExpression = "0/1 * * * * ?";
		TaskOptions options = new TaskOptions();
		options.setAllowOverlap(true);
		options.setMaxConcurrent(10);
		options.setDebug(true);
		ScheduledFuture task = scheduler.schedule(new Runnable()
		{

			public void run()
			{
				try
				{
					Thread.sleep(5000);
				}
				catch (InterruptedException e)
				{
					e.printStackTrace();
				}
			}
		}, cronExpression, options);
		System.out.println(new Date()
				+ " next execution "
				+ new Date(System.currentTimeMillis()
						+ task.getDelay(TimeUnit.MILLISECONDS)));
		Thread.sleep(15000);
		scheduler.shutdown(false); // cancel all tasks but let currently
									// executing tasks terminate
		Thread.sleep(7000);
	}

}
