package org.rzo.yacron4j.example;

import java.text.ParseException;
import java.util.Date;
import java.util.TimeZone;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

import org.rzo.yacron4j.Scheduler;
import org.rzo.yacron4j.TaskOptions;

public class VancouverDST
{

	/**
	 * @param args
	 * @throws ParseException
	 */
	public static void main(String[] args) throws Exception
	{
		Scheduler scheduler = new Scheduler();
		String cronExpression = "0 15 2 8 3 ? 2015";
		TaskOptions options = new TaskOptions();
		options.setTimeZone(TimeZone.getTimeZone("America/Vancouver"));
		// options.setDstConflictIgnore(true); // -> will cause null pointer
		// exception (as with quartz): March 8th 2:15 does not exit in vancouver
		options.setDstConflictResolution(1); // -> should the trigger be at
												// 01:15
												// (DST_CONFLICT_BACKWARD),
												// 03:00
												// (DST_CONFLICT_IMMEDIATE),
												// 03:15 (DST_CONFLICT_FORWARD)
												// ?
		ScheduledFuture task = scheduler.schedule(new Runnable()
		{

			public void run()
			{
				System.out.println("" + new Date() + " running "
						+ Thread.currentThread().getName());
				try
				{
					Thread.sleep(5000);
				}
				catch (InterruptedException e)
				{
					e.printStackTrace();
				}
			}
		}, cronExpression, options);
		System.out.println(new Date(System.currentTimeMillis()
				+ task.getDelay(TimeUnit.MILLISECONDS)));
		Thread.sleep(15000);
		scheduler.shutdown();
	}

}
